function doSplashStartupLoop()
{
  EnsureServicesReady();
  window.openDialog("chrome://pcenv/content/pcenv.xul", "mainWindow",
                    "chrome,dialog=no,all");
  window.close();
}

function EnsureServicesReady()
{
try
{
  if (window.servicesReady != null)
    return;

  // Get the preparer ready...
  // Components.classes["@cellml.org/cellml-preparer;1"].
  //  createInstance(Components.interfaces.nsISupports);

  var cc = Components.classes;
  var ci = Components.interfaces;

  window.bootstrap = cc["@cellml.org/cellml-bootstrap;1"].
    getService(ci.cellml_apiICellMLBootstrap);

  window.context = cc["@cellml.org/cellml-context-bootstrap;1"].
    getService(ci.cellml_contextICellMLContext);

  // Get the RDF Service...
  window.rdfservice =
    cc["@mozilla.org/rdf/rdf-service;1"].
    getService(ci.nsIRDFService);

  // Get the RDF container utilities...
  window.rdfcu =
    cc["@mozilla.org/rdf/container-utils;1"].
    getService(ci.nsIRDFContainerUtils);

  // Get the CellML Code Generation Service...
  window.ccgs =
    cc["@cellml.org/ccgs-bootstrap;1"].
    getService(ci.cellml_servicesICGenerator);
  
  // Get the CellML Integration Service...
  window.cis =
    cc["@cellml.org/cis-bootstrap;1"].
    getService(ci.cellml_servicesICellMLIntegrationService);

  // Get the MathML Input Services...
  window.mis = cc["@cellml.org/tools/pcenv/mathmlInputServices;1"].
    getService(ci.IMathMLInputServices);

  window.mathContentToPresentation = new XSLTProcessor();
  var req = new XMLHttpRequest();
  req.open('GET', 'chrome://pcenv/skin/xsl/mathmlc2p.xsl', false);
  req.send(null);
  window.mathContentToPresentation.importStylesheet(req.responseXML);
  window.domParser = new DOMParser();

  window.servicesReady = true;
}
catch (e)
{
  alert("Caught exception: " + e);
}
}

function StartMainWindow()
{
  EnsureServicesReady();
  var ns = Components.classes["@cellml.org/pcenv/notification-service;1"].
    getService(Components.interfaces.nsICommandLine);
  var l = ns.length;
  var i;
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
  for (i = 0; i < l; i++)
  {
    try
    {
      var url = ioService.newURI(ns.getArgument(i), null, null).spec;
      OpenHTTPRequest(url, null);
    }
    catch (e)
    {
      try
      {
        var f = Components.classes["@mozilla.org/file/local;1"].
          createInstance(Components.interfaces.nsILocalFile);
        f.initWithPath(ns.getArgument(i));
        OpenHTTPRequest(ioService.newFileURI(f).spec, null);
      }
      catch (e2)
      {
        alert("Invalid URL on command line: " + ns.getArgument(i) + ": " + e2);
      }
    }
  }
}

function StopMainWindow()
{
  // This is needed to stop leaks (this is presumably a Mozilla bug, because
  //   window should get garbage collected, but I haven't been able to narrow it
  //   down yet).
  window.context = null;
  window.bootstrap = null;
}

function Status(x)
{
  document.getElementById("statusbar").setAttribute("label", x);
}
