function UIFileNew()
{
  //Status("Getting new model name...");
  //var fn = prompt("What should the new model be called?");
  //if (fn == null)
  //{
  //  Status("New cancelled.");
  //  return;
  //}
  //Status("New model is called " + fn);
  
  // Next, create an empty model...
  //window.context.cellmlBootstrap.modelLoader.createModel();
  Status("Bringing up new model dialog...");
  window.openDialog("chrome://pcenv/content/dialog/create_model.xul",
                    "_blank", "chrome,modal", window);
}

function DoSave(model, file)
{
  try
  {
    var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
                 createInstance(Components.interfaces.nsIFileOutputStream);
    const MODE_WRONLY = 0x02;
    const MODE_CREATE   = 0x08;
    const MODE_TRUNCATE = 0x20;
    strm.init(file, MODE_WRONLY | MODE_CREATE | MODE_TRUNCATE, 0644, 0);
    var data = model.serialisedText;
    strm.write(data, data.length);
    Status("Model saved.");
  }
  catch (e)
  {
    Status("Could not write to the file.");
  }
}

function UIFileOpen()
{
  Status("Bringing up the open model dialog...");
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"]
                     .createInstance(nsIFilePicker);
  fp.init(window, "Select a model file", nsIFilePicker.modeOpenMultiple);
  fp.appendFilter("CellML Models","*.cml; *.cellml; *.xml");
  fp.appendFilter("XML Files","*.xml");
  fp.appendFilter("All Files","*");
  if (fp.show() != nsIFilePicker.returnOK)
  {
    Status("Open dialog cancelled.");
    return;
  }
  var f = fp.files;
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
  while ((f.hasMoreElements()))
  {
    var url = ioService.newFileURI(f.getNext().QueryInterface(
                                   Components.interfaces.nsIFile)).spec;
    OpenHTTPRequest(url, null);
  }
}

function UIFileSave()
{
  var m = window.modelSelector.currentModel;
  if (m == null)
  {
    Status("You must select a model to save first.");
    return;
  }
  
  var mm = m.model;

  // See if we can convert the base URI to a local file URL to save to...
  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);

  try
  {
    var file = ioService.newURI(mm.base_uri.asText, null, null).
        QueryInterface(Components.interfaces.nsIFileURL).file;
  }
  catch (e)
  {
    UIFileSaveAs();
  }
  DoSave(mm, file);
}

function UIFileSaveAs()
{
  var m = window.modelSelector.currentModel;
  if (m == null)
  {
    Status("You must select a model to save first.");
    return;
  }
  
  Status("Bringing up the save model dialog...");
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"]
                     .createInstance(nsIFilePicker);
  fp.init(window, "Select a model file", nsIFilePicker.modeSave);
  fp.appendFilter("CellML Models","*.cml; *.cellml; *.xml");
  fp.appendFilter("XML Files","*.xml");
  fp.appendFilter("All Files","*");
  if (fp.show() == nsIFilePicker.returnCancel)
  {
    Status("Save dialog cancelled.");
    return;
  }
  var mm = m.model;

  var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
  var url = ioService.newFileURI(fp.file).spec;
  mm.base_uri.asText = url;

  DoSave(mm, fp.file);
}

function UIFileSaveAll()
{
}

function toJavaScriptConsole()
{
  toOpenWindowByType("global:console", "chrome://global/content/console.xul");
}

function toOpenWindowByType(inType, uri, features)
{
  var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
  var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
  var topWindow = windowManagerInterface.getMostRecentWindow(inType);

  if (topWindow)
    topWindow.focus();
  else if (features)
    window.open(uri, "_blank", features);
  else
    window.open(uri, "_blank", "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar");
}

function UILaunchJSConsole()
{
  toJavaScriptConsole();
}

function WriteCSVData(datacollector, cmodel, stream)
{
  var header = '';
  var varit = cmodel.codeInformation.iterateVariables();
  var vars = [];
  var i;
  var v, bv;
  while ((v = varit.nextVariable()) != null)
    if (v.type == 0/* BOUND*/)
      bv = v.source.name + '(' + v.source.unitsName + ')';
    else if (v.type == 1/* CONSTANT */)
      ;
    else
      vars[v.variableIndex] = v.source.name + '(' + v.source.unitsName + ')';
  var vc = cmodel.codeInformation.variableCount;
  for (i = 0; i < vc; i++)
  {
    if (header != '')
      header = header + ',';
    header = header + vars[i];
  }
  if (bv != null)
  {
    if (header != '')
      header = header + ',';
    header = header + bv;
  }
  header = header + "\n";
  stream.write(header, header.length);

  vc = vc + 1;
  try
  {
    var t = 0;
    while (true)
    {
      var line = "";
      for (i = 0; i < vc; i++)
      {
        if (line != '')
          line = line + ',';
        line = line + datacollector.getRawData(i, t);
      }
      line = line + '\n';
      stream.write(line, line.length);
      t = t + 1;
    }
  }
  catch (e)
  {
  }
}

function UIExportCSV()
{
  var m = window.modelSelector.currentModel.model;
  if (m == null)
  {
    Status("No model to export as CSV selected.");
    return;
  }
  var dc = EnsureDataCollector(m);
  if (dc.status != Components.interfaces.IDataCollector.STATUS_DONE)
  {
    Status("Integration not complete; can't export data.");
    return;
  }
  var cm = GetTag(m, "compiled_model").compModel;

  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"]
                     .createInstance(nsIFilePicker);
  fp.init(window, "Select a file to export to", nsIFilePicker.modeSave);
  fp.appendFilter("CSV Files","*.csv; *.txt");
  fp.appendFilter("All Files","*");
  if (fp.show() == nsIFilePicker.returnCancel)
  {
    Status("Export dialog cancelled.");
    return;
  }
  
  try
  {
    var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
                 createInstance(Components.interfaces.nsIFileOutputStream);
    const MODE_WRONLY = 0x02;
    const MODE_CREATE   = 0x08;
    const MODE_TRUNCATE = 0x20;
    strm.init(fp.file, MODE_WRONLY | MODE_CREATE | MODE_TRUNCATE, 0644, 0);

    WriteCSVData(dc, cm, strm);
    Status("Model exported.");
  }
  catch (e)
  {
    Status("Could not write to the file.");
  }
}

function UISetGraphCount(count)
{
  document.getElementById("layout").setGraphCount(count);
}

function UISetTieX(control)
{
  var val = !(control.hasAttribute("checked"));
  if (val)
    control.setAttribute("checked", "true");
  else
    control.removeAttribute("checked");
  window.tieXAxisMode = val;
  if (window.tieXAxisObservers == null || !val)
    return;
  var i;
  var tie = null;
  for (i in window.tieXAxisObservers)
  {
    // Items earlier in the array control the scale of later items.
    tie = window.tieXAxisObservers[i].computeXAxisTie(tie);
  }
}

function UISetGridlines(control)
{
  var val = !(control.hasAttribute("checked"));
  if (val)
    control.setAttribute("checked", "true");
  else
    control.removeAttribute("checked");
  window.gridLineMode = val;
  if (window.gridlineObservers == null)
    return;
  var i;
  for (i in window.gridlineObservers)
  {
    // Items earlier in the array control the scale of later items.
    window.gridlineObservers[i].setGridLines(val);
  }
}

function UISaveDefaultSession()
{
  var ds = Components.classes["@mozilla.org/file/directory_service;1"].
    createInstance(Components.interfaces.nsIProperties);
  var pd = ds.get("ProfD", Components.interfaces.nsIFile);
  pd.append("session.rdf");
  WriteSessionTo(pd);
}

function UIExportSession()
{
  Status("Bringing up the export session dialog...");
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"]
                     .createInstance(nsIFilePicker);
  fp.init(window, "Select a session file", nsIFilePicker.modeSave);
  fp.appendFilter("PCEnv Session Files","*.session; *.rdf; *.xml");
  fp.appendFilter("RDF Files","*.rdf; *.xml");
  fp.appendFilter("XML Files","*.xml");
  fp.appendFilter("All Files","*");
  if (fp.show() == nsIFilePicker.returnCancel)
  {
    Status("Export session dialog cancelled.");
    return;
  }
  WriteSessionTo(fp.file);
}

function UILoadDefaultSession()
{
  var ds = Components.classes["@mozilla.org/file/directory_service;1"].
    createInstance(Components.interfaces.nsIProperties);
  var pd = ds.get("ProfD", Components.interfaces.nsIFile);
  pd.append("session.rdf");
  ReadSessionFrom(pd);
}


function UIImportSession()
{
  Status("Bringing up the import session dialog...");
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"]
                     .createInstance(nsIFilePicker);
  fp.init(window, "Select a session file", nsIFilePicker.modeOpen);
  fp.appendFilter("PCEnv Session Files","*.session; *.rdf; *.xml");
  fp.appendFilter("RDF Files","*.rdf; *.xml");
  fp.appendFilter("XML Files","*.xml");
  fp.appendFilter("All Files","*");
  if (fp.show() == nsIFilePicker.returnCancel)
  {
    Status("Export session dialog cancelled.");
    return;
  }
  ReadSessionFrom(fp.file);
}
