function EnsureDataCollector(model)
{
  var t = GetTag(model, "data_collector");
  if (t == null)
    t = TagWithName(model, "data_collector");
  if (t.collector != null)
    return t.collector;
  t.collector = Components.classes["@cellml.org/tools/pcenv/datacollector;1"].
    createInstance(Components.interfaces.IDataCollector);
  return t.collector;
}

function StartCollectingResults(collector, model, stepType, epsAbs, epsRel,
                                scalVar, scalRate, startBvar, stopBvar,
                                maxDensity, maxstep)
{
  Status("Compiling the model...");
  var compModel = window.cis.compileModel(window.ccgs, model);

  var t = TagWithName(model, "compiled_model");
  t.compModel = compModel;

  // Call all integration start handlers to inform them...
  var i;
  if (window.integrationStartHandlers == null)
    window.integrationStartHandlers = [];
  for (i in window.integrationStartHandlers)
    window.integrationStartHandlers[i].
      integrationStarted(startBvar, stopBvar, maxDensity, compModel);

  Status("Model compiled, configuring integrator...");
  var codeInfo = compModel.codeInformation;
  
  collector.initialise(codeInfo.constantCount, codeInfo.variableCount,
                       startBvar, stopBvar, maxDensity);

  var run = window.cis.createIntegrationRun(compModel);
  run.stepType = stepType;
  run.setStepSizeControl(epsAbs, epsRel, scalVar, scalRate, maxstep);
  run.setResultRange(startBvar, stopBvar, maxDensity);
  run.setProgressObserver(ProxyToMain(collector,
                                      Components.interfaces.IDataCollector));
  Status("Starting the integrator...");
  run.start();
  Status("Integration now started.");
  TagWithName(model, "integration_run").run = run;
}
