const contractID = "@cellml.org/pcenv/notification-service;1";
const CID = Components.ID("{6a0bad39-9fca-4b96-8387-3a75dd09f335}");

pcenvNotificationService.prototype = {
  QueryInterface: function(iid) {
    if (iid.equals(Components.interfaces.nsICommandLine))
      return this.cmdline;
    if (!iid.equals(Components.interfaces.nsICommandLineHandler) &&
        !iid.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  },

  handle: function (cmdline)
  {
    this.cmdline = cmdline;
  }
};

function pcenvNotificationService()
{
}

var PCEnvNotificationsModule = {
  registered: false,

  registerSelf: function(compMgr, fileSpec, location, type)
  {
    if (this.registered)
      return;

    var compReg = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compReg.registerFactoryLocation(CID, "PCEnv Notifications", contractID,
                                    fileSpec, location, type);
    var catman = Components.classes['@mozilla.org/categorymanager;1']
                   .getService(Components.interfaces.nsICategoryManager);
    catman.addCategoryEntry("command-line-handler", "m-pcenvnotifications",
                            contractID, true, true);
  },

  unregisterSelf: function(compMgr, location, type)
  {
    var catman = Components.classes['@mozilla.org/categorymanager;1']
                   .getService(Components.interfaces.nsICategoryManager);
    catman.deleteCategoryEntry("command-line-handler", "m-pcenvnotifications",
                               true);
  },

  getClassObject: function(compMgr, cid, iid) {
    if (cid.equals(CID))
      return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  createInstance: function mod_CI(outer, iid) {
    if (outer != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    return new pcenvNotificationService().QueryInterface(iid);
  }
};

function NSGetModule(cm, file)
{
  return PCEnvNotificationsModule;
}
